#include <stdio.h>
#include <stdarg.h>
double add(int firstArg, ...);

int main(void)
{
	double total;

	total = add(1, 3.0, 4.0, '-');

	printf("total is %f\n", total);

	return 0;
}




double add (int NumberOfOps, ...)
{
	va_list VariableArgsPtr;
	char    operation;
	double  sum, number;
	int     i;

	va_start(VariableArgsPtr, NumberOfOps);

	sum = va_arg(VariableArgsPtr, double);

	for (i=0; i<NumberOfOps; ++i)
	{

		number = va_arg(VariableArgsPtr, double);
		operation = va_arg(VariableArgsPtr, char);   /* non-portable */

		switch(operation) {
			case '+': sum += number; printf("  received +\n"); break;
			case '-': sum -= number; printf("  received -\n"); break;
		}

	}

	return sum;
}
